# Ogre::Resource Class Reference

Abstract class reprensenting a loadable resource (e.g. More...

`#include <OgreResource.h>`

Inheritance diagram for Ogre::Resource:

List of all members.

## Public Member Functions

| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | load (void)
| Loads the resource, if it is not already.
virtual void | reload (void)
| Reloads the resource, if it is already loaded.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
const String & | getName (void) const
| Gets resource name.
ResourceHandle | getHandle (void) const
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
const String & | getGroup (void)
| Gets the group which this resource is a member of.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.

## Static Public Member Functions

void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Protected Member Functions

| Resource ()
| Protected unnamed constructor to prevent default construction.
virtual void | loadImpl (void)=0
| Internal implementation of the 'load' action, only called if this resource is not being loaded from a ManualResourceLoader.
virtual void | unloadImpl (void)=0
| Internal implementation of the 'unload' action; called regardless of whether this resource is being loaded from a ManualResourceLoader.
virtual size_t | calculateSize (void) const=0
| Calculate the size of a resource; this will only be called after 'load'.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.

## Protected Attributes

ResourceManager * | mCreator
| Creator.
String | mName
| Unique name of the resource.
String | mGroup
| The name of the resource group.
ResourceHandle | mHandle
| Numeric handle for more efficient look up than name.
bool | mIsLoaded
| Is the resource currently loaded?
size_t | mSize
| The size of the resource in bytes.
bool | mIsManual
| Is this file manually loaded?
String | mOrigin
| Origin of this resource (e.g. script name) - optional.
ManualResourceLoader * | mLoader
| Optional manual loader; if provided, data is loaded from here instead of a file.
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).

## Static Protected Attributes

ParamDictionaryMap | msDictionary
| Dictionary of parameters.

## Detailed Description

Abstract class reprensenting a loadable resource (e.g.

textures, sounds etc)

Remarks:
  Resources are data objects that must be loaded and managed throughout an application. A resource might be a mesh, a texture, or any other piece of data - the key thing is that they must be identified by a name which is unique, must be loaded only once, must be managed efficiently in terms of retrieval, and they may also be unloadable to free memory up when they have not been used for a while and the memory budget is under stress.

  All Resource instances must be a member of a resource group; see ResourceGroupManager for full details.

  Subclasses must implement:
  1. A constructor, overriding the same parameters as the constructor defined by this class. Subclasses are not allowed to define constructors with other parameters; other settings must be settable through accessor methods before loading.
  2. The loadImpl() and unloadImpl() methods - mSize must be set after loadImpl()
  3. StringInterface ParamCommand and ParamDictionary setups in order to allow setting of core parameters (prior to load) through a generic interface.

Definition at line 67 of file OgreResource.h.

## Constructor & Destructor Documentation

Ogre::Resource::Resource | ( |  | ) | `[protected]`

| Protected unnamed constructor to prevent default construction. Definition at line 93 of file OgreResource.h.

Ogre::Resource::Resource | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0
| ) |

Standard constructor.

Parameters:

  creator | Pointer to the ResourceManager that is creating this resource
  name | The unique name of the resource
  group | The name of the resource group to which this resource belongs
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualResourceLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualResourceLoader instance is strongly recommended.

virtual Ogre::Resource::~Resource | ( |  | ) | `[virtual]`

Virtual destructor.

Shouldn't need to be overloaded, as the resource deallocation code should reside in unload()

See also:
  Resource::unload()

## Member Function Documentation

void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) |

| Notify this resource of it's origin. Definition at line 214 of file OgreResource.h. References Ogre::String.

virtual size_t Ogre::Resource::calculateSize | ( | void |  | ) | const`[protected, pure virtual]`

| Calculate the size of a resource; this will only be called after 'load'. Implemented in Ogre::Font, Ogre::GpuProgram, Ogre::Material, Ogre::Mesh, Ogre::Skeleton, Ogre::Texture, and Ogre::BspLevel.

void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. MaterialManager) initializes.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 296 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and Ogre::StringInterface::setParameter().

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 172 of file OgreStringInterface.h.

References Ogre::String.

ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) |

| Gets the manager which created this resource. Definition at line 205 of file OgreResource.h.

const String& Ogre::Resource::getGroup | ( | void |  | ) |

| Gets the group which this resource is a member of. Definition at line 202 of file OgreResource.h. References Ogre::String.

ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const

| Definition at line 188 of file OgreResource.h. References Ogre::ResourceHandle.

const String& Ogre::Resource::getName | ( | void |  | ) | const

| Gets resource name. Definition at line 183 of file OgreResource.h. References Ogre::String.

const String& Ogre::Resource::getOrigin | ( | void |  | ) | const

Get the origin of this resource, e.g.

a script file name.

Remarks:
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

Definition at line 212 of file OgreResource.h.

References Ogre::String.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

| Definition at line 209 of file OgreStringInterface.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 196 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 265 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), Ogre::ParamDictionary::getParamCommand(), and Ogre::String.

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

size_t Ogre::Resource::getSize | ( | void |  | ) | const

| Retrieves info about the size of the resource. Definition at line 172 of file OgreResource.h.

bool Ogre::Resource::isLoaded | ( | void |  | ) | const

| Returns true if the Resource has been loaded, false otherwise. Definition at line 195 of file OgreResource.h. References OGRE_LOCK_AUTO_MUTEX.

bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const

| Is this resource manually loaded? Definition at line 160 of file OgreResource.h.

bool Ogre::Resource::isReloadable | ( | void |  | ) | const

| Returns true if the Resource is reloadable, false otherwise. Definition at line 153 of file OgreResource.h.

virtual void Ogre::Resource::load | ( | void |  | ) | `[virtual]`

Loads the resource, if it is not already.

Remarks:
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own

Reimplemented in Ogre::Mesh, and Ogre::GLSLGpuProgram.

virtual void Ogre::Resource::loadImpl | ( | void |  | ) | `[protected, pure virtual]`

| Internal implementation of the 'load' action, only called if this resource is not being loaded from a ManualResourceLoader. Implemented in Ogre::Font, Ogre::GpuProgram, Ogre::HighLevelGpuProgram, Ogre::Material, Ogre::Mesh, Ogre::PatchMesh, Ogre::Skeleton, Ogre::SkeletonInstance, Ogre::BspLevel, Ogre::D3DTexture, Ogre::D3D9GpuProgram, Ogre::D3D9Texture, and Ogre::GLTexture.

virtual void Ogre::Resource::reload | ( | void |  | ) | `[virtual]`

Reloads the resource, if it is already loaded.

Remarks:
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  paramList | Name/value pair list

virtual void Ogre::Resource::touch | ( | void |  | ) | `[virtual]`

| 'Touches' the resource to indicate it has been used. Reimplemented in Ogre::Material.

virtual void Ogre::Resource::unload | ( | void |  | ) | `[virtual]`

| Unloads the resource; this is not permanent, the resource can be reloaded later if required. Reimplemented in Ogre::GLSLGpuProgram.

virtual void Ogre::Resource::unloadImpl | ( | void |  | ) | `[protected, pure virtual]`

Internal implementation of the 'unload' action; called regardless of whether this resource is being loaded from a ManualResourceLoader.

Implemented in Ogre::Font, Ogre::HighLevelGpuProgram, Ogre::Material, Ogre::Mesh, Ogre::Skeleton, Ogre::SkeletonInstance, Ogre::Texture, Ogre::BspLevel, Ogre::D3D7GpuProgram, Ogre::D3D9GpuVertexProgram, Ogre::D3D9GpuFragmentProgram, Ogre::GLGpuNvparseProgram, Ogre::GLGpuProgram, and Ogre::GLArbGpuProgram.

## Member Data Documentation

ResourceManager* Ogre::Resource::mCreator `[protected]`

| Creator. Definition at line 73 of file OgreResource.h.

String Ogre::Resource::mGroup `[protected]`

| The name of the resource group. Definition at line 77 of file OgreResource.h.

ResourceHandle Ogre::Resource::mHandle `[protected]`

| Numeric handle for more efficient look up than name. Definition at line 79 of file OgreResource.h.

bool Ogre::Resource::mIsLoaded `[protected]`

| Is the resource currently loaded? Definition at line 81 of file OgreResource.h.

bool Ogre::Resource::mIsManual `[protected]`

| Is this file manually loaded? Definition at line 85 of file OgreResource.h.

ManualResourceLoader* Ogre::Resource::mLoader `[protected]`

| Optional manual loader; if provided, data is loaded from here instead of a file. Definition at line 89 of file OgreResource.h.

String Ogre::Resource::mName `[protected]`

| Unique name of the resource. Definition at line 75 of file OgreResource.h.

String Ogre::Resource::mOrigin `[protected]`

| Origin of this resource (e.g. script name) - optional. Definition at line 87 of file OgreResource.h.

String Ogre::StringInterface::mParamDictName `[protected, inherited]`

| Class name for this instance to be used as a lookup (must be initialised by subclasses). Definition at line 160 of file OgreStringInterface.h.

ParamDictionaryMap Ogre::StringInterface::msDictionary `[static, protected, inherited]`

| Dictionary of parameters. Definition at line 157 of file OgreStringInterface.h.

size_t Ogre::Resource::mSize `[protected]`

| The size of the resource in bytes. Definition at line 83 of file OgreResource.h.

The documentation for this class was generated from the following file:

- OgreResource.h

Copyright © 2000-2005 by The OGRE Team
Last modified Sun Nov 20 12:39:00 2005